using System;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Media;
using System.Windows.Shapes;
using System.Windows.Input;
using System.Windows.Markup;
using System.ComponentModel;
using System.ComponentModel.Design.Serialization;
using System.Collections.Generic;
using System.Reflection;
using System.Text;
using System.Threading;
using System.Diagnostics;
using Infragistics.Windows;
using Infragistics.Windows.Themes;

namespace Infragistics.Windows.Themes.Internal
{
	/// <summary>
	/// Loads the themes contained in this assembly.
	/// </summary>
	public class WindowsAssemblyResourceSetLoader : AssemblyResourceSetLoader
	{
		/// <summary>
		/// Loads and registers the resource sets for the specified <paramref name="groupingName"/>
		/// </summary>
		/// <param name="groupingName">The name of the grouping whose resources should be loaded or null if all resource sets should be loaded.</param>
		// AS 11/6/07 ThemeGroupingName
		//protected override void OnRegisterResourceSets()
		protected override void OnRegisterResourceSets(string groupingName)
		{
			// AS 11/6/07 ThemeGroupingName
			if (groupingName == PrimitivesGeneric.GroupingName || null == groupingName)
			{
				/* AS 5/7/08
				AssemblyResourceSetLoader.RegisterResourceSet(PrimitivesGeneric.Instance);
				AssemblyResourceSetLoader.RegisterResourceSet(PrimitivesOnyx.Instance);
				AssemblyResourceSetLoader.RegisterResourceSet(PrimitivesAero.Instance);
				AssemblyResourceSetLoader.RegisterResourceSet(PrimitivesRoyale.Instance);
				AssemblyResourceSetLoader.RegisterResourceSet(PrimitivesRoyaleStrong.Instance);
				AssemblyResourceSetLoader.RegisterResourceSet(PrimitivesLunaNormal.Instance);
				AssemblyResourceSetLoader.RegisterResourceSet(PrimitivesLunaOlive.Instance);
				AssemblyResourceSetLoader.RegisterResourceSet(PrimitivesLunaSilver.Instance);
				AssemblyResourceSetLoader.RegisterResourceSet(PrimitivesOffice2k7Blue.Instance);
				AssemblyResourceSetLoader.RegisterResourceSet(PrimitivesOffice2k7Black.Instance);
				AssemblyResourceSetLoader.RegisterResourceSet(PrimitivesOffice2k7Silver.Instance);
				*/
				AssemblyResourceSetLoader.RegisterResourceSet(PrimitivesGeneric.Location);
				AssemblyResourceSetLoader.RegisterResourceSet(PrimitivesOnyx.Location);
				AssemblyResourceSetLoader.RegisterResourceSet(PrimitivesAero.Location);
				AssemblyResourceSetLoader.RegisterResourceSet(PrimitivesRoyale.Location);
				AssemblyResourceSetLoader.RegisterResourceSet(PrimitivesRoyaleStrong.Location);
				AssemblyResourceSetLoader.RegisterResourceSet(PrimitivesLunaNormal.Location);
				AssemblyResourceSetLoader.RegisterResourceSet(PrimitivesLunaOlive.Location);
				AssemblyResourceSetLoader.RegisterResourceSet(PrimitivesLunaSilver.Location);
				// JJD 2/16/12 - Added Metro theme
				AssemblyResourceSetLoader.RegisterResourceSet(PrimitivesMetro.Location);
				AssemblyResourceSetLoader.RegisterResourceSet(PrimitivesMetroDark.Location); // AS 7/8/13 - Added MetroDark theme
				AssemblyResourceSetLoader.RegisterResourceSet(PrimitivesOffice2k7Blue.Location);
				AssemblyResourceSetLoader.RegisterResourceSet(PrimitivesOffice2k7Black.Location);
				AssemblyResourceSetLoader.RegisterResourceSet(PrimitivesOffice2k7Silver.Location);
				// JJD 10/29/10 - Added IGTheme
                AssemblyResourceSetLoader.RegisterResourceSet(PrimitivesIGTheme.Location);
				// JJD 8/30/10 - Added Office 2010 Blue theme
				AssemblyResourceSetLoader.RegisterResourceSet(PrimitivesOffice2010Blue.Location);
                // JJD 12/12/13 - NA 2014 vol 1 - Added Office 2013 theme
                AssemblyResourceSetLoader.RegisterResourceSet(PrimitivesOffice2013.Location);

                // JJD 06/07/16 - NA 2016 vol 1 - Added RoyalDark Theme
                AssemblyResourceSetLoader.RegisterResourceSet(PrimitivesRoyalDark.Location);

                // JJD 06/15/17 - NA 2017 vol 2 - Added RoyalLight Theme
                AssemblyResourceSetLoader.RegisterResourceSet(PrimitivesRoyalLight.Location);
            }
        }
	}
}
